/*
    Copyright (C) 2010 wpitchoune@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _PSENSOR_PSENSOR_H_
#define _PSENSOR_PSENSOR_H_

#include <sensors/sensors.h>

// number of stored temperature
#define MAX_TEMPS 600

#define SENSOR_TYPE_LMSENSOR 0
#define SENSOR_TYPE_NVIDIA   1

struct psensor {
	char *name;
	char *chip_name;

	const sensors_chip_name *iname;
	const sensors_feature *feature;

	double temps[MAX_TEMPS];	// index 0 for the oldest temperature

	double color[3];	// rgb 0..1

	int enabled;

	int type;

	int nvidia_id;

	double max;
	double min;
};

int psensor_init();

int get_min_temp(struct psensor **sensors);
int get_max_temp(struct psensor **sensors);

void update_psensor(struct psensor *sensor);

struct psensor *create_sensor(const sensors_chip_name * chip,
			      const sensors_feature * feature);

void psensor_free(struct psensor *sensor);
void psensor_list_free(struct psensor **sensors);

struct psensor **get_all_sensors();

#endif
